#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MAX_A = 1'000'000'000'000;
const ll MAX_W = 1'000'000'000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    const int max_n = opt<int>("n");
    const string special = has_opt("s") ? opt<string>("s") : "";

    int n = 2 + rnd.wnext(max_n - 1, 5);

    const int max_m = (int) min((ll) opt<int>("m"), ((ll) n * (ll) (n - 1)) / 2);
    int m;
    if (special == "each1" || special == "eachn") {
        m = n - 1;
    } else {
        m = rnd.next(1, max_m);
    }

    ll max_a = has_opt("a") ? opt<ll>("a") : MAX_A;
    ll max_w = has_opt("w") ? opt<ll>("w") : MAX_W;

    set<pair<int, int>> eg;

    println(n, m);
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        a[i] = rnd.next(1LL, max_a);
    }
    println(a);

    if (special == "each1") {
        vector<int> order = rnd.perm(n - 1, 2);
        for (int i = 0; i < n - 1; ++i) {
            ll w = rnd.next(1LL, max_w);
            println(1, order[i], w);
        }
    } else if (special == "eachn") {
        vector<int> order = rnd.perm(n - 1, 1);
        for (int i = 0; i < n - 1; ++i) {
            ll w = rnd.next(1LL, max_w);
            println(n, order[i], w);
        }
    } else {
        for (int i = 0; i < m; ++i) {
            int u, v;
            while (true) {
                u = rnd.next(1, n);
                v = rnd.next(1, n);
                if (u != v && eg.count(make_pair(min(u, v), max(u, v))) == 0) {
                    break;
                }
            }
            eg.emplace(min(u, v), max(u, v));
            ll w = rnd.next(1LL, max_w);
            println(u, v, w);
        }
    }

    return 0;
}
