#include <functional>
#include <algorithm>
#include "testlib.h"

using namespace std;

using ll = long long;

const ll max_a = 1'000'000'000'000;
const ll max_w = 1'000'000'000;
const int max_n = 200'000;
const int max_m = 500'000;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(2, max_n, "n");
    inf.readSpace();
    int m = inf.readInt(1, (int) min((ll) max_m, ((ll) n * ((ll) n - 1)) / 2), "m");
    inf.readEoln();

    inf.readLongs(n, 1, max_a, "a");
    inf.readEoln();

    set<pair<int, int>> edges;
    vector<vector<int>> graph(n);
    for (int i = 0; i < m; ++i) {
        int u = inf.readInt(1, n, "u");
        inf.readSpace();
        int v = inf.readInt(1, n, "v");
        inf.readSpace();
        inf.readLong(1, max_w, "w");
        inf.readEoln();
        graph[u - 1].push_back(v - 1);
        graph[v - 1].push_back(u - 1);

        ensuref(u != v, "should be not self assigned edge (%d)", i + 1);
        if (u > v) { swap(u, v); }
        ensuref(edges.find(make_pair(u, v)) == edges.end(), "all edges should be unique (%d)", i + 1);
        edges.emplace(u, v);
    }

    inf.readEof();

//    vector<bool> visited(n);
//    function<void(int u)> dfs = [&](int u) {
//        visited[u] = true;
//        for (int v : graph[u]) {
//            if (!visited[v]) { dfs(v); }
//        }
//    };
//    dfs(0);
//    for (int i = 0; i < n; ++i) {
//        ensuref(visited[i], "node %d not connected with other graph", i + 1);
//    }
}