using namespace std;

#include <iostream>
#include <iomanip>
#include <vector>
#include <queue>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <functional>

#define X first
#define Y second

using ll = long long;

const double DIFF = 1e-16;
const double MAX = 1e6;

int main() {
    int n;
    int m;

    cin >> n >> m;

    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector < vector < pair < int, ll>>> edges(n);

    for (int i = 0; i < m; ++i) {
        int u, v;
        ll w;
        cin >> u >> v >> w;
        --u, --v;
        edges[u].emplace_back(v, w);
        edges[v].emplace_back(u, w);
    }

    priority_queue<pair<ll, int>> qq;

    for (int i = 0; i < n; ++i) {
        qq.emplace(a[i], i);
    }

    while (!qq.empty()) {
        auto [d, u] = qq.top();
        qq.pop();

        for (auto [v, w] : edges[u]) {
            if (a[u] + w < a[v]) {
                a[v] = a[u] + w * 2;
                qq.emplace(a[v], v);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        cout << a[i] << " ";
    }
    cout << "\n";
}
