//
// Quentined and tarantined by Written Directino
//
#include <bits/stdc++.h>

using namespace std;
const int MAX_N = int(1e5 + 13);

struct cow {
    int x;
    int index;
};

struct node {
    int left;
    int right;
    int add;
    cow minCow;
    cow maxCow;
};

struct grass {
    int taste;
    int x;
    int index;
};

bool operator<(const grass &a, const grass &b) {
    return a.taste < b.taste;
}

bool operator<(const cow &a, const cow &b) {
    return a.x < b.x || (a.x == b.x && a.index < b.index);
}

node tree[MAX_N * 4];
vector<cow> cows;

void push(int v) {
    if (tree[v].left == tree[v].right - 1) {
        tree[v].add = 0;
        return;
    }
    tree[v * 2].add += tree[v].add;
    tree[v * 2 + 1].add += tree[v].add;
    tree[v * 2].minCow.x += tree[v].add;
    tree[v * 2 + 1].minCow.x += tree[v].add;
    tree[v * 2].maxCow.x += tree[v].add;
    tree[v * 2 + 1].maxCow.x += tree[v].add;
    tree[v].add = 0;
}

void recount(int v) {
    if (tree[v].left == tree[v].right - 1) {
        return;
    }
    tree[v].minCow = tree[v * 2].minCow;
    tree[v].maxCow = tree[v * 2 + 1].maxCow;
    if (tree[v * 2].maxCow.x == tree[v].maxCow.x && tree[v * 2].maxCow.index < tree[v].maxCow.index) {
        tree[v].maxCow = tree[v * 2].maxCow;
    }
}

void build(int v, int l, int r) {
    tree[v].left = l;
    tree[v].right = r;
    if (l == r - 1) {
        tree[v].maxCow = tree[v].minCow = cows[l];
        tree[v].add = 0;
        return;
    }
    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid, r);

    recount(v);
}

void add_seg(int v, int x, int d) {
    push(v);
    if (x <= tree[v].minCow.x || x >= tree[v].maxCow.x) {
        if (x <= tree[v].minCow.x) {
            d *= -1;
        }
        tree[v].add += d;
        tree[v].minCow.x += d;
        tree[v].maxCow.x += d;
        return;
    }
    add_seg(v * 2, x, d);
    add_seg(v * 2 + 1, x, d);
    recount(v);
}

cow find_place(int v, int x) {
    push(v);
    if (tree[v].right - 1 == tree[v].left) {
        return tree[v].minCow;
    }
    int l1 = tree[v * 2].minCow.x;
    int r1 = tree[v * 2].maxCow.x;
    int l2 = tree[v * 2 + 1].minCow.x;
    int r2 = tree[v * 2 + 1].maxCow.x;

    if (x < l1) {
        return tree[v].minCow;
    } else if (l1 <= x && x < r1) {
        return find_place(v * 2, x);
    } else if (r1 <= x && x < l2) {
        int d1 = abs(x - r1);
        int d2 = abs(x - l2);
        if (d1 < d2) {
            return tree[v * 2].maxCow;
        } else if (d1 > d2) {
            return tree[v * 2 + 1].minCow;
        } else {
            if (tree[v * 2].maxCow.index < tree[v * 2 + 1].minCow.index) {
                return tree[v * 2].maxCow;
            } else {
                return tree[v * 2 + 1].minCow;
            }
        }
    } else if (l2 <= x && x < r2) {
        return find_place(v * 2 + 1, x);
    } else {
        return tree[v].maxCow;
    }
}

int main() {
    int n, m;

    cin >> n;
    cows.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> cows[i].x;
        cows[i].index = i;
    }

    sort(cows.begin(), cows.end());
    build(1, 0, n);
    cin >> m;
    vector<grass> g (m);
    for (int i = 0; i < m; i++) {
        cin >> g[i].taste >> g[i].x;
        g[i].index = i;
    }

    vector<int> ans (m);
    sort(g.begin(), g.end());
    reverse(g.begin(), g.end());
    for (const auto &[t, x, i]: g) {
        cow res = find_place(1, x);
        ans[i] = res.index;
        add_seg(1, x, abs(res.x - x));
    }

    for (int x: ans) {
        cout << x + 1 << '\n';
    }
}