#include <bits/stdc++.h>

using namespace std;

#define int long long
const int INF = 1e15;
int n;

struct segtree {
    struct node {
        int mx, mn, x, cow_id, a, tree_id;
    };
    vector<node> tree;
    int sz = 1;

    void merge(node &to, node &l, node &r) {
        to.mx = max(l.mx, r.mx);
        to.mn = min(l.mn, r.mn);
    }

    void build(vector<pair<int, int>> &a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x].tree_id = lx;
            if (lx < a.size()) {
                tree[x].x = tree[x].mn = tree[x].mx = a[lx].first;
                tree[x].cow_id = a[lx].second;
            } else {
                tree[x].mn = INF;
                tree[x].mx = -INF;
                tree[x].cow_id = -1;
            }
            return;
        }
        int m = (lx + rx) / 2;
        build(a, 2 * x + 1, lx, m);
        build(a, 2 * x + 2, m, rx);
        merge(tree[x], tree[2 * x + 1], tree[2 * x + 2]);
    }

    void init(vector<pair<int, int>> &a) {
        while (sz < a.size()) {
            sz *= 2;
        }
        tree.resize(2 * sz + 1);
        build(a, 0, 0, sz);
    }

    void push(int x) {
        if (tree[x].a == 0) {
            return;
        }
        if (tree[2 * x + 1].mx != -INF) {
            tree[2 * x + 1].x += tree[x].a;
            tree[2 * x + 1].mx += tree[x].a;
            tree[2 * x + 1].mn += tree[x].a;
            tree[2 * x + 1].a += tree[x].a;
        }
        if (tree[2 * x + 2].mx != -INF) {
            tree[2 * x + 2].x += tree[x].a;
            tree[2 * x + 2].mx += tree[x].a;
            tree[2 * x + 2].mn += tree[x].a;
            tree[2 * x + 2].a += tree[x].a;
        }
        tree[x].a = 0;
    }

    void set(int i, int v) {
        set(i, v, 0, 0, sz);
    }

    void set(int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x].cow_id = v;
            return;
        }
        push(x);
        int m = (lx + rx) / 2;
        if (tree[2 * x + 1].mx >= i && tree[2 * x + 1].mn <= i) {
            set(i, v, 2 * x + 1, lx, m);
        }
        if (tree[2 * x + 2].mx >= i && tree[2 * x + 2].mn <= i) {
            set(i, v, 2 * x + 2, m, rx);
        }
    }

    void add(int l, int r, int v) {
        add(l, r, v, 0, 0, sz);
    }

    void add(int l, int r, int v, int x, int lx, int rx) {
        if (lx >= l && rx <= r) {
            tree[x].a += v;
            tree[x].x += v;
            if (tree[x].mx != -INF) {
                tree[x].mx += v;
            }
            if (tree[x].mn != INF) {
                tree[x].mn += v;
            }
            return;
        }
        if (lx >= r || rx <= l) {
            return;
        }
        int m = (lx + rx) / 2;
        push(x);
        add(l, r, v, 2 * x + 1, lx, m);
        add(l, r, v, 2 * x + 2, m, rx);
        merge(tree[x], tree[2 * x + 1], tree[2 * x + 2]);
    }

    tuple<int, int, int> first_gr(int v) {
        return first_gr(v, 0, 0, sz);
    }

    tuple<int, int, int> first_gr(int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            if (tree[x].mx != -INF && tree[x].x >= v) {
                return {tree[x].x, tree[x].cow_id, tree[x].tree_id};
            }
            return {INF, -1, n};
        }
        push(x);
        int m = (lx + rx) / 2;
        if (tree[2 * x + 1].mx >= v) {
            return first_gr(v, 2 * x + 1, lx, m);
        }
        return first_gr(v, 2 * x + 2, m, rx);
    }

    tuple<int, int, int> last_le(int v) {
        return last_le(v, 0, 0, sz);
    }

    tuple<int, int, int> last_le(int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            if (tree[x].mx != -INF && tree[x].x <= v) {
                return {tree[x].x, tree[x].cow_id, tree[x].tree_id};
            }
            return {-INF, -1, -1};
        }
        push(x);
        int m = (lx + rx) / 2;
        if (tree[2 * x + 2].mn <= v) {
            return last_le(v, 2 * x + 2, m, rx);
        }
        return last_le(v, 2 * x + 1, lx, m);
    }

};

struct gr {
    int x, t, id;
    friend bool operator<(gr &lhs, gr &rhs) {
        return lhs.t > rhs.t;
    }
};

signed main() {
    cin >> n;
    vector<pair<int, int>> cowstmp(n);
    for (int i = 0; i < n; i++) {
        cin >> cowstmp[i].first;
        cowstmp[i].second = i;
    }
    sort(cowstmp.begin(), cowstmp.end());
    vector<pair<int, int>> cows;
    cows.push_back(cowstmp[0]);
    for (int i = 1; i < n; i++) {
        if (cowstmp[i].first != cows.back().first) {
            cows.push_back(cowstmp[i]);
        }
    }
    segtree st;
    st.init(cows);
    int m;
    cin >> m;
    vector<gr> grass(m);
    for (int i = 0; i < m; i++) {
        cin >> grass[i].t >> grass[i].x;
        grass[i].id = i;
    }
    sort(grass.begin(), grass.end());
    vector<int> ans(m);
    for (int i = 0; i < m; i++) {
        auto le = st.last_le(grass[i].x);
        auto ri = st.first_gr(grass[i].x);
        int ledist = grass[i].x - get<0>(le);
        int ridist = get<0>(ri) - grass[i].x;
        if (ledist < ridist || (ledist == ridist && get<1>(le) < get<1>(ri))) {
            ans[grass[i].id] = get<1>(le);
        } else {
            ans[grass[i].id] = get<1>(ri);
        }
        st.add(0, get<2>(le) + 1, min(ledist, ridist));
        st.add(get<2>(ri), cows.size(), -min(ledist, ridist));
        if (ledist == ridist) {
            st.set(grass[i].x, ans[grass[i].id]);
        }
    }
    for (auto el : ans) {
        cout << el + 1 << "\n";
    }
}
