#include "testlib.h"

using namespace std;

typedef array<array<char, 3>, 3> field;

vector<tuple<int, int, int, int>> directions = {
        {0, 0, 1, 0},
        {0, 0, 0, 1},
        {0, 0, 1, 1},
        {1, 0, 0, 1},
        {2, 0, 0, 1},
        {0, 1, 1, 0},
        {0, 2, 1, 0},
        {0, 2, 1, -1},
};


void check(InStream &in) {
    field F;
    map<char, int> cnt;
    cnt['0'] = 0;
    cnt['#'] = 0;
    cnt['X'] = 0;
    for (int x = 0; x < 3; ++x) {
        for (int y = 0; y < 3; ++y) {
            F[x][y] = in.readChar();
            ++cnt[F[x][y]];
            in.ensuref(F[x][y] == 'X' || F[x][y] == '0' || F[x][y] == '#',
                       "field char unexpected %c at position (%d, %d)", F[x][y], x + 1, y + 1);
        }
        in.readEoln();
    }
    in.readEof();

    for (char c: vector<char>({'X', '#'})) {
        for (int di = 0; di < directions.size(); ++di) {
            auto d = directions[di];
            bool win = true;
            for (int i = 0; i < 3; ++i) {
                int x = get<0>(d) + i * get<2>(d);
                int y = get<1>(d) + i * get<3>(d);
                win = win && F[x][y] == c;
            }
            in.ensuref(!win, "player %c won win direction %d, but should not", c, di);
        }
    }
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    check(ans);
    check(ouf);

    quitf(_ok, "Answers match");

}