#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

using namespace std;

typedef long long ll;
typedef long double ld;

vector<tuple<int, int, int, int>> directions = {
        {0, 0, 1, 0},
        {0, 0, 0, 1},
        {0, 0, 1, 1},
        {1, 0, 0, 1},
        {2, 0, 0, 1},
        {0, 1, 1, 0},
        {0, 2, 1, 0},
        {0, 2, 1, -1},
};

void print_direction(int d) {
    vector<pair<int, int>> od;
    for (int i = 0; i < 3; ++i) {
        od.emplace_back(
                get<0>(directions[d]) + i * get<2>(directions[d]),
                get<1>(directions[d]) + i * get<3>(directions[d])
        );
    }
    shuffle(od.begin(), od.end());
    for (auto e: od) {
        println(e.first + 1, e.second + 1);
    }
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    const int d1 = has_opt("d1") ? opt<int>("d1") : rnd.next(8);
    const int d2 = has_opt("d2") ? opt<int>("d2") : rnd.next(8);

    print_direction(d1);
    print_direction(d2);

    vector<pair<int, int>> free;
    for (int i = 0; i < 9; ++i) {
        free.emplace_back(i / 3 + 1, i % 3 + 1);
    }
    shuffle(free.begin(), free.end());
    for (int i = 0; i < 9; ++i) {
        println(free[i].first, free[i].second);
    }

    return 0;
}
