//
// Created by Daniil Oreshnikov on 20.11.2024.
//
 
#include "testlib.h"
#include <vector>
#include <set>
#include <unordered_set>
 
using namespace std;
 
int main(int argc, char *argv[]) {
 
    registerGen(argc, argv, 1);
 
    int n = opt<int>("n"), m = opt<int>("m");
    int tree_w = opt<int>("tw");
 
    vector<int> p(n);
    set<pair<int, int>> edges;
 
    for (int i = 1; i < n; i++) {
        if (tree_w > 0) {
            p[i] = rnd.wnext(0, min(tree_w, i - 1), -1);
        } else if (tree_w < 0) {
            p[i] = rnd.wnext(max(0, i + tree_w), i - 1, 1);
        } else {
            p[i] = rnd.next(0, i - 1);
        }
        edges.emplace(i, p[i]);
    }
 
    for (int i = n - 1; i < m; i++) {
        int u = 0, v = 0;
        while (u == v || edges.count({u, v})) {
            u = rnd.next(n);
            v = rnd.next(n);
            if (u < v) swap(u, v);
        }
        edges.emplace(u, v);
    }
 
    println(n, m);
    for (auto [u, v] : edges) {
        if (rnd.next(2)) swap(u, v);
        println(u + 1, v + 1);
    }
 
}
