//
// Created by Daniil Golov on 04.11.2024.
//
#include "testlib.h"

using namespace std;
const int MAX_N = 100'000;
const int MAX_A = 1'000'000'000;

int main(int argc, char *argv[]){
    registerTestlibCmd(argc, argv);
    int n = inf.readInt(1, MAX_N, "n");
    int ja = ans.readInt(-1, MAX_A, "ja");
    int pca = ouf.readInt(-1, MAX_A, "pa");
    if (pca == -1) {
        if (ja != -1) {
            quitf(_wa, "Jury found answer, participant didn't");
        } else {
            quitf(_ok, "n=%d, ans=-1", n);
        }
    }
    vector<int> pa (n);
    pa[0] = pca;
    for (int i = 1; i < n; i++) {
        pa[i] = ouf.readInt(1, MAX_A, "pa_i");
    }
    set<int> inp;
    for (int i = 0; i < n; i++) {
        inp.insert(inf.readInt(1, MAX_A, "a_i"));
    }

    set<int> s1, s2;
    for (int x: pa) {
        if (inp.find(x) != inp.end()) {
            inp.erase(x);
        } else {
            quitf(_wa, "unknown number: %d", x);
        }

        s2.insert(x);
        if (s2.size() - s1.size() > 1) {
            auto t = s2.begin();
            s1.insert(*t);
            s2.erase(t);
        }

        if (s1.size() == s2.size()) {
            int medianx2 = *s1.rbegin() + *s2.begin();
            if (medianx2 % 2 != 0) {
                quitf(_wa, "median is not int when adding %d", x);
            }
        }
    }

    if (ja == -1) {
        quitf(_fail, "Participant found answer, jury didn't");
    }
    quitf(_ok, "n=%d", n);
}